<template lang="pug">
  div.lc-donate
    div.ui.stackable.container.centered
      h1 Donate
      p.subtitle We love money, give us some!
      p.ui.segment.inverted.left.aligned
        | Our projects are #[span.highlight free] to use and #[span.highlight open] to everyone, all of their functions, as well as the code.
        | But running public services takes money and resources, so we need #[span.highlight your help]!
        | We call out to the #[span.highlight community] to help finance some of those projects.
        | #[span.highlight No limitations], no VIP features for special users and guilds, full equality for everyone using them.
        | And we want to keep it that way for as long as possible.
        | Some are big, very big, huge in fact, Like #[span.highlight Sigma], a bot with this many features is heavy to take care of.
        | Numerous searches that use various APIs, websites constantly being scraped for data, and a music core that supports over 1040 sources!
        | Let's not go back to the olden days of when music functions were limited to partnered servers and keep it open for everyone.
    div.padding
    div.lc.header.centered
      h2 Methods
      p.subtitles Pick your preferred way.
    div.ui.container
      div.ui.three.column.stackable.grid
        div.five.wide.column
          div.ui.segment.inverted.centered
            h3 #[i.patreon.icon] Patreon
            p.ui.segment.inverted.left.aligned
              | The method that helps us the most is a monthly subscription.
              | And you can do by using Patreon. As a bonus, Patreon supporters get some cool nifty things,
              | such as a colored ribbon in the donor section beneath, special commands being made for them,
              | they also get to name Sigma's version. For the highest tiers I ran out of ideas, so let's negotiate.
            a.ui.button.inverted(href="https://www.patreon.com/luciascipher" target="_blank") Subscribe
        div.five.wide.column
          div.ui.segment.inverted.centered
            h3 #[i.paypal.icon] PayPal
            p.ui.segment.inverted.left.aligned
              | In case you don't want to or can't commit to a monthly subscription
              | but still want to help you can send money directly via PayPal and its PayPal.me page.
              | Every little bit counts and makes a difference.
              | While rewards are limited to only Patreon supporters,
              | donating via PayPal will still reserve you a spot in the donor section with an ashen colored ribbon.
            a.ui.button.inverted(href="https://www.paypal.me/AleksaRadovic" target="_blank") Donate
        div.five.wide.column
          div.ui.segment.inverted.centered
            h3 #[i.gitlab.icon] GitLab
            p.ui.segment.inverted.left.aligned
              | Some projects are, as mentioned, very large, and there's only a handful of people working on them.
              | We would love it if you could lend a hand with development.
              | The repository is on GitLab and fully open source to anyone willing to contribute.
              | While this unfortunatelly yields no notable rewards, it will assure you a Dev role on our official server.
            a.ui.button.inverted(href="https://gitlab.com/lu-ci" target="_blank") Contribute
    //- div.padding
    //- div.lc.header.centered
    //-   h2 Donors
    //-   p.subtitle The lovely people that helped us out!
    //-   div.ui.container.segment.inverted(v-if="loading")
    //-     div.ui.active.inline.text.loader.inverted.centered.sigma-stats-loader(v-if="loading") Loading...
    //-   div.ui.container.segment.inverted.centered(v-else)
    //-     div.ui.five.column.stackable.grid
    //-       donor(v-for="donor in donors" :name="donor.user.name" :avatar="donor.user.avatar_url" :tier="donor.tier" :key="donor.user.id")
</template>

<script lang="ts">
import Donor from '@/comps/Donor.vue'
import LuciaGQLCore from '@/data/gql'
import { Component, Vue } from 'vue-property-decorator'

const gql = new LuciaGQLCore()

/* eslint-disable camelcase */
interface DonorGQLItem {
  tier: number,
  user: {
    id: number,
    name: string,
    avatar_url: string
  }
}
/* eslint-enable camelcase */

interface DonorsGQLResponse {
  donors: DonorGQLItem[]
}

function updateDonors (ctx: LCDonate) {
  const qry = `{
    donors {
      tier
      user {
        name
        avatar_url: avatarUrl
      }
    }
  }`

  const req: Promise<DonorsGQLResponse> = gql.request(qry)
  req.then((data: DonorsGQLResponse) => {
    ctx.donors = data.donors
    ctx.loading = false
  })
}

@Component({ components: { Donor } })
export default class LCDonate extends Vue {
  loading = true
  donors: DonorGQLItem[] = []
  mounted () {
    // updateDonors(this)
  }
}
</script>

<style lang="stylus" scoped>
accent = #866be1

.highlight
  color: accent

.ui.three.column.stackable.grid > .five.wide.column
  width: 30.9% !important

@media only screen and (max-device-width : 720px)
  .ui.three.column.stackable.grid > .five.wide.column
    width: 100% !important

.ui.five.column.stackable.grid > .three.wide.column
  width: 17.5% !important

@media only screen and (max-device-width : 1200px)
  .ui.five.column.stackable.grid > .three.wide.column
    width: 22% !important

@media only screen and (max-device-width : 720px)
  .ui.five.column.stackable.grid > .three.wide.column
    width: 31% !important
    padding-right: 1rem !important

@media only screen and (max-device-width : 480px)
  .ui.five.column.stackable.grid > .three.wide.column
    width: 100% !important
</style>
